//================================================================================
// BloodyMess mutator.   Rewrite of a couple of The Danes code fragments
// into a functional mutator.   By Mr.Loathsome and The Dane.  v3.9   04/16/2011
//================================================================================
class BM extends Mutator config(BloodyMess);

var config bool bHeadshotOnly, bRandLevel, bGBPlus;
var config float SpawnRate;
var config int SpurtLevel, NumDrops;
var bool bInit, bDoSpawn, bSBM;

function PostBeginPlay()
{
	if (bInit) return; else bInit = True;
	bDoSpawn = True;
	SpawnRate = FClamp(SpawnRate, 0.025, 20.0);
	SpurtLevel = Clamp(SpurtLevel, 1, 512);
	NumDrops = Clamp(NumDrops, 1, 512);
	Level.Game.RegisterDamageMutator( Self );
	Super.PostBeginPlay();
}

function Timer()
{
	bDoSpawn = True;
}

function bool PreventDeath (Pawn Killed, Pawn Killer, name damageType, vector HitLocation)
{
local int nd;
local BDSpawn b;

	bSBM = True;
	if (( bHeadshotOnly ) && ( damageType != 'Decapitated' ))
		bSBM = False;
	if (Killed != None && bSBM && bDoSpawn)
		{
		if (bRandLevel) nd = Rand(NumDrops) + 1; else nd = NumDrops;
		b = Spawn(class'BDSpawn', Killed);
		if (b != None)
			b.Bds(nd, HitLocation);
		SetTimer(SpawnRate, False);
		bDoSpawn = False;
		}
	if ( NextMutator != None )
		return NextMutator.PreventDeath(Killed, Killer, damageType, HitLocation);
	return false;
}

function MutatorTakeDamage(out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, out Vector Momentum, name DamageType)
{
	if ((ScriptedPawn(Victim) != None) && (bGBPlus) && ((Victim.isA('Pupae')) || (Victim.isA('Slith'))))
		ScriptedPawn(Victim).bGreenBlood = True;
	Super.MutatorTakeDamage(ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);
}

defaultproperties
{
    bHeadshotOnly=False
    bRandLevel=False
    bGBPlus=True
    SpawnRate=0.450
    SpurtLevel=40
    NumDrops=60
}
